//
//  ViewController.m
//  QRParserAppObj
//
//  Created by Patel, Khagesh Kumar on 12/7/16.
//  Copyright © 2016 Visa Inc. All rights reserved.
//

#import "ViewController.h"
#import <MVisaQRParser/MVisaQRParser.h>
@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    NSString *tlvStr = @"00020103031230102110208476136175204601053033565802IN5912Corner Store6006Mumbai610640110462250302AM060612345605054567863043188";
    self.tlvTextView.text = tlvStr;
    QRCodeParserResponse *parserResponse = [QRCodeParser parseQRDataWithQrCodeString:tlvStr];
    [self displayQRData:parserResponse];
    
 //    [QRCodeParser parseQRDataWithQrCodeString:tlvStr completionHandler:^(QRCodeParserResponse *codeParserResponse) {
//        [self displayQRData:codeParserResponse];
//    }];
    
    [QRCodeParser parseQRDataForStringWithQrCodeString:tlvStr completionHandler:^(NSString *jsonData) {
        
        NSLog(@"%@", jsonData);
    }];
}

- (void)displayQRData:(QRCodeParserResponse *)parserResponse {
    
    if (parserResponse.qrCodeError) {
        
        NSLog(@"Error : %@",parserResponse.qrCodeError.description);
        self.outputTextView.text = parserResponse.qrCodeError.description;
    }
    else {
        
        QRCodeData *qrCodeData = parserResponse.qrCodeData;
        NSLog(@"Response :\n %@",parserResponse.qrCodeData.description);
        NSLog(@"JSON Response :\n %@",parserResponse.qrCodeData.jsonOutput);
        NSString *dataStr = @"\n";
        dataStr = [dataStr stringByAppendingFormat:@"mVisaMerchantID = %@\n",(qrCodeData.mVisaMerchantID?qrCodeData.mVisaMerchantID:@"nil")];
        dataStr = [dataStr stringByAppendingFormat:@"mVisaMerchantPAN = %@\n",(qrCodeData.mVisaMerchantPAN?qrCodeData.mVisaMerchantPAN:@"nil")];
        dataStr = [dataStr stringByAppendingFormat:@"merchantName = %@\n",(qrCodeData.merchantName?qrCodeData.merchantName:@"nil")];
        dataStr = [dataStr stringByAppendingFormat:@"merchantCategoryCode = %@\n",(qrCodeData.merchantCategoryCode?qrCodeData.merchantCategoryCode:@"nil")];
        
        self.outputTextView.text = dataStr;
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];

}


@end
