//
//  ViewController.swift
//  MVisaDecoderQAApp
//
//  Created by Patel, Khagesh Kumar on 12/6/16.
//  Copyright © 2016 Patel, Khagesh Kumar. All rights reserved.
//

import UIKit
import MVisaQRParser

class ViewController: UIViewController {
    @IBOutlet weak var tlvTextView: UITextView!
    @IBOutlet weak var outputTextView: UITextView!
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        
        let tlvString = "000201021647613688400000145204412153033565802IN5912Corner Store6006Mumbai62050901B6304A2D8"
        
        tlvTextView.text = tlvString
        QRCodeParser.parseQRData(qrCodeString: tlvString) { (parserResponse) in
            
            if ((parserResponse!.qrCodeData) != nil) {
                
                //read tlvResponse object
                self.logForAllVariables(parserResponse!.qrCodeData!)
                self.outputTextView.text = parserResponse!.qrCodeData?.description
            }
            else {
                
                //show error
                print("Error Code: " + parserResponse!.qrCodeError!.description + "\n");
                self.outputTextView.text = parserResponse!.qrCodeError!.description
            }
        }
        
        
        // With Sync method
//        let parserResponse = QRCodeParser.parseQRData(qrCodeString: tlvString)
//        if ((parserResponse.qrCodeData) != nil) {
//            
//            //read tlvResponse object
//            self.logForAllVariables(parserResponse.qrCodeData!)
//            self.outputTextView.text = parserResponse.qrCodeData?.description
//        }
//        else {
//            
//            //show error
//            print("Error Code: " + parserResponse.qrCodeError!.description + "\n");
//            self.outputTextView.text = parserResponse.qrCodeError!.description
//        }

        QRCodeParser.parseQRDataForString(qrCodeString: tlvString) { (jsonData) in
            
            print(jsonData ?? "No Data")
        }
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    func logForAllVariables(_ qrCodeData: QRCodeData) {
        
        print("JSON Parsed QR Code: " + qrCodeData.jsonOutput + "\n");

        func getStr(_ varName: String?) -> String {
            return (varName == nil ? "nil" : varName!)
        }
        
        var dataStr = "\n"
        
        dataStr = dataStr + "mVisaMerchantID: " + getStr(qrCodeData.mVisaMerchantID) + "\n"
        dataStr = dataStr + "mVisaMerchantPAN: " + getStr(qrCodeData.mVisaMerchantPAN) + "\n"
        dataStr = dataStr + "merchantName: " + getStr(qrCodeData.merchantName) + "\n"
        dataStr = dataStr + "merchantCategoryCode: " + getStr(qrCodeData.merchantCategoryCode) + "\n"
        dataStr = dataStr + "cityName: " + getStr(qrCodeData.cityName) + "\n"
        dataStr = dataStr + "countryCode: " + getStr(qrCodeData.countryCode) + "\n"
        dataStr = dataStr + "currencyCode: " + getStr(qrCodeData.currencyCode) + "\n"
        dataStr = dataStr + "transactionAmount: " + getStr(qrCodeData.transactionAmount) + "\n"
        dataStr = dataStr + "primaryID: " + getStr(qrCodeData.primaryID) + "\n"
        dataStr = dataStr + "secondaryID: " + getStr(qrCodeData.secondaryID) + "\n"
        dataStr = dataStr + "tipAndFeeIndicator: " + getStr(qrCodeData.tipAndFeeIndicator) + "\n"
        dataStr = dataStr + "convenienceFeeAmount: " + getStr(qrCodeData.convenienceFeeAmount) + "\n"
        dataStr = dataStr + "convenienceFeePercentage: " + getStr(qrCodeData.convenienceFeePercentage) + "\n"
        
        dataStr = dataStr + "payloadFormatIndicator: " + getStr(qrCodeData.payloadFormatIndicator) + "\n"
        dataStr = dataStr + "pointOfInitiation: " + getStr(qrCodeData.pointOfInitiation) + "\n"
        dataStr = dataStr + "postalCode: " + getStr(qrCodeData.postalCode) + "\n"
        dataStr = dataStr + "masterCardPAN1: " + getStr(qrCodeData.masterCardPAN1) + "\n"
        dataStr = dataStr + "masterCardPAN2: " + getStr(qrCodeData.masterCardPAN2) + "\n"
        dataStr = dataStr + "npciid1: " + getStr(qrCodeData.npciid1) + "\n"
        dataStr = dataStr + "npciid2: " + getStr(qrCodeData.npciid2) + "\n"
        dataStr = dataStr + "crc: " + getStr(qrCodeData.crc) + "\n"
        
        dataStr = dataStr + "billID: " + getStr(qrCodeData.billID) + "\n"
        dataStr = dataStr + "mobileNumber: " + getStr(qrCodeData.mobileNumber) + "\n"
        dataStr = dataStr + "storeID: " + getStr(qrCodeData.storeID) + "\n"
        dataStr = dataStr + "loyaltyNumber: " + getStr(qrCodeData.loyaltyNumber) + "\n"
        dataStr = dataStr + "referenceID: " + getStr(qrCodeData.referenceID) + "\n"
        dataStr = dataStr + "consumerID: " + getStr(qrCodeData.consumerID) + "\n"
        dataStr = dataStr + "terminalID: " + getStr(qrCodeData.terminalID) + "\n"
        dataStr = dataStr + "purpose: " + getStr(qrCodeData.purpose) + "\n"
        dataStr = dataStr + "additionalConsumerDataRequest: " + getStr(qrCodeData.additionalConsumerDataRequest) + "\n"
        dataStr = dataStr + "addDataMasterCard1: " + getStr(qrCodeData.addDataMasterCard1) + "\n"
        dataStr = dataStr + "addDataMasterCard2: " + getStr(qrCodeData.addDataMasterCard2) + "\n"
        dataStr = dataStr + "addDataNpci1: " + getStr(qrCodeData.addDataNpci1) + "\n"
        dataStr = dataStr + "addDataNpci2: " + getStr(qrCodeData.addDataNpci2) + "\n"
        
        dataStr = dataStr + "isBillIDMandatory: " + String(qrCodeData.isBillIDMandatory) + "\n"
        dataStr = dataStr + "isMobileNumberMandatory: " + String(qrCodeData.isMobileNumberMandatory) + "\n"
        dataStr = dataStr + "isStoreIDMandatory: " + String(qrCodeData.isStoreIDMandatory) + "\n"
        dataStr = dataStr + "isLoyaltyNumberMandatory: " + String(qrCodeData.isLoyaltyNumberMandatory) + "\n"
        dataStr = dataStr + "isReferenceIDMandatory: " + String(qrCodeData.isReferenceIDMandatory) + "\n"
        dataStr = dataStr + "isConsumerIDMandatory: " + String(qrCodeData.isConsumerIDMandatory) + "\n"
        dataStr = dataStr + "isTerminalIDMandatory: " + String(qrCodeData.isTerminalIDMandatory) + "\n"
        dataStr = dataStr + "isPurposeMandatory: " + String(qrCodeData.isPurposeMandatory) + "\n"
        dataStr = dataStr + "isAdditonalConsumerDataRequestMandatory: " + String(qrCodeData.isAdditonalConsumerDataRequestMandatory) + "\n"
        dataStr = dataStr + "isAddDataMasterCard1Mandatory: " + String(qrCodeData.isAddDataMasterCard1Mandatory) + "\n"
        dataStr = dataStr + "isAddDataMasterCard2Mandatory: " + String(qrCodeData.isAddDataMasterCard2Mandatory) + "\n"
        dataStr = dataStr + "isAddDataNpci1Mandatory: " + String(qrCodeData.isAddDataNpci1Mandatory) + "\n"
        dataStr = dataStr + "isAddDataNpci2Mandatory: " + String(qrCodeData.isAddDataNpci2Mandatory) + "\n"
        
        dataStr = dataStr + "isPrimaryIDMandatory: " + String(qrCodeData.isPrimaryIDMandatory) + "\n"
        dataStr = dataStr + "isSecondaryIDMandatory: " + String(qrCodeData.isSecondaryIDMandatory) + "\n"
        
        dataStr = dataStr + "primaryIDLength: " + getStr(qrCodeData.primaryIDLength) + "\n"
        dataStr = dataStr + "secondaryIDLength: " + getStr(qrCodeData.secondaryIDLength) + "\n"
        
//        print("Parsed QR Code: " + dataStr + "\n");
    }


}

